/*******************************************************************************
*                                 ZM4xx Demo
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx Demo
 *
 * - 裺
 *   1. S3 лģʽ 
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
#include "stddef.h" 
#include "LPC11xx.h"
#include "uart.h"
#include "stdint.h"
#include "radio.h"
#include "int.h"
#include "stdio.h"


static radio_handle_t __gp_handle;

/**
 * \brief  S3жϷ,лģʽ
 */
static void __key3_int_handle (void) 
{   
    static uint8_t mode = 1;
    switch (mode) {
    case 0:
        radio_mode_set(__gp_handle, SLEEP_MODE);
        printf("\r\n Into sleep mode \r\n");
        mode = 1;
        break;
    
    case 1:
        radio_mode_set(__gp_handle, STANDBY_MODE);
        printf("\r\n Into standby mode \r\n");
        mode = 2;
        break;
    
    case 2:
        radio_mode_set(__gp_handle, RX_MODE);
        printf("\r\n Into rx mode \r\n");
        mode = 3;
        break;
    
    case 3:
        radio_mode_set(__gp_handle, TX_MODE);
        printf("\r\n Into tx mode \r\n");
        mode = 0;
        break;
    
    default:
        break;
    }
}


void demo_zm4xx_mode_entry (radio_handle_t handle)
{
    __gp_handle = handle;

    radio_mode_set(handle, SLEEP_MODE);
    printf("\r\n Into sleep mode \r\n");
    key3_int_init(__key3_int_handle);

    while (1) {        
    }
}

