/*******************************************************************************
*                                 Timer Driver 
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief Timer
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */

#include "LPC11xx.h"
#include "timer.h"

void timer0_16_init(void)
{
   LPC_SYSCON->SYSAHBCLKCTRL |= (1<<7);    //ʹTIM16B0ʱ
   LPC_TMR16B0->IR  = 0x01;           //MR0жϸλ,ж
   LPC_TMR16B0->MCR = 0x04;  //MR0жϲʱֹͣTCPCֹͣʱ
}




void timer0_32_init (void)
{
   LPC_SYSCON->SYSAHBCLKCTRL |= (1 << 9);    //ʹTIM32B0ʱ
   LPC_TMR32B0->IR  = 0x3F;                  //ж
   //LPC_TMR32B0->MCR = 0x04;  //MR0жϲʱֹͣTCPCֹͣʱ
}   




void timer0_32_start (void)
{
   LPC_TMR32B0->TCR = 0x02;          //λʱbit1д1λ
   LPC_TMR32B0->PR  = 44236800 / 1000000 - 1;          // 1΢TC+1
   LPC_TMR32B0->TCR = 0x01;          //ʱTCR[0]=1;
}




uint32_t timer0_32_stop (void)
{
   LPC_TMR32B0->TCR = 0x00;          //ֹͣʱ
   return LPC_TMR32B0->TC;
}




void timer0_16_delay_ms(uint16_t ms)
{
   LPC_TMR16B0->TCR = 0x02;          //λʱbit1д1λ
   LPC_TMR16B0->PR  = 44236800/1000-1;        // 1TC+1
   LPC_TMR16B0->MR0 = ms;     // ע⣺MR016λĴֵҪ65535
   LPC_TMR16B0->TCR = 0x01;          //ʱTCR[0]=1;
   while (LPC_TMR16B0->TCR & 0x01);//ȴʱʱʱ䵽
}




void timer0_16_delay_us(uint16_t us)
{
   LPC_TMR16B0->TCR = 0x02;          //λʱbit1д1λ
   LPC_TMR16B0->PR  = 44236800/1000000-1;          // 1΢TC+1
   LPC_TMR16B0->MR0 = us;      // ע⣺MR016λĴֵҪ65535
   LPC_TMR16B0->TCR = 0x01;          //ʱTCR[0]=1;
   while (LPC_TMR16B0->TCR & 0x01);//ȴʱʱʱ䵽
}

uint32_t timer0_32_tc_get (void)
{
   return LPC_TMR32B0->TC;
}
